clear all; clc; close all;

load data/Section4/LaborTax0/plotting_vectors.mat
taulvec_opt1 = taulvec_opt;
output_vec_opt1 = output_vec_opt;
DY1 = DY;

load data/Section4/LaborTax05/plotting_vectors.mat
taulvec_opt2 = taulvec_opt;
output_vec_opt2 = output_vec_opt;
DY2 = DY;

load data/Section4/LaborTax1/plotting_vectors.mat
taulvec_opt3 = taulvec_opt;
output_vec_opt3 = output_vec_opt;
DY3 = DY;

load data/Section4/MyopicLaborUnion/plotting_vectors.mat
taulvec_opt4 = taulvec_opt;
output_vec_opt4 = output_vec_opt;

[obj,i5] = min(abs(timevec - 5));
[obj,i10] = min(abs(timevec - 10));

%5-YEAR GROWTH RATES
growth5 = [(log(output_vec_lf(i5)) - log(output_vec_lf(1)))/5;
(log(output_vec_opt1(i5)) - log(output_vec_opt1(1)))/5;
(log(output_vec_opt2(i5)) - log(output_vec_opt2(1)))/5;
(log(output_vec_opt3(i5)) - log(output_vec_opt3(1)))/5;
(log(output_vec_opt4(i5)) - log(output_vec_opt4(1)))/5]

growth10 = [(log(output_vec_lf(i10)) - log(output_vec_lf(1)))/10;
(log(output_vec_opt1(i10)) - log(output_vec_opt1(1)))/10;
(log(output_vec_opt2(i10)) - log(output_vec_opt2(1)))/10;
(log(output_vec_opt3(i10)) - log(output_vec_opt3(1)))/10;
(log(output_vec_opt4(i10)) - log(output_vec_opt4(1)))/10]


N=length(timevec);

Tmax = 50;
figure(2)
set(gcf,'PaperPosition',[0 0 15 5])
subplot(1,2,1)
h1 = plot(timevec,zeros(1,N),'b--',timevec,taulvec_opt1,'r:',timevec,taulvec_opt2,'k-.',timevec,taulvec_opt3,'g',timevec,taulvec_opt4,'m--','LineWidth',2);
set(gca,'FontSize',16)
legend(h1,'Equilibrium','Planner, \theta= 0','Planner, \theta= 1/2','Planner, \theta= 1','Myopic Labor Union','Location','SouthEast')
xlim([0 Tmax])
title('(a) Labor Tax, $\tau_\ell(t)$','interpreter','latex')
xlabel('Years','FontSize',16,'interpreter','latex')
set(findobj('color','g'),'Color',[0 0.5 0]);

subplot(1,2,2)
h1 = plot(timevec,output_vec_lf/output_vec_lf(end),'b--',timevec,output_vec_opt1/output_vec_lf(end),'r:',timevec,output_vec_opt2/output_vec_lf(end),'k-.',timevec,output_vec_opt3/output_vec_lf(end),'g',timevec,output_vec_opt4/output_vec_lf(end),'m--','LineWidth',2);
set(gca,'FontSize',16)
legend(h1,'Equilibrium','Planner, \theta= 0','Planner, \theta= 1/2','Planner, \theta= 1','Myopic Labor Union','Location','SouthEast')
xlim([0 Tmax])
title('(b) GDP, $Y(t)$','interpreter','latex')
xlabel('Years','FontSize',16,'interpreter','latex')
set(findobj('color','g'),'Color',[0 0.5 0]);

print -depsc graphs/fig_numerical.eps

DY(1)
DY(end)

clear all
load data/Section4/CreditSubsidy0/plotting_vectors.mat
taulvec_opt1 = taulvec_opt;
output_vec_opt1 = output_vec_opt;
DY1 = DY;

load data/Section4/CreditSubsidy05/plotting_vectors.mat
taulvec_opt2 = taulvec_opt;
output_vec_opt2 = output_vec_opt;
DY2 = DY;

load data/Section4/CreditSubsidy1/plotting_vectors.mat
taulvec_opt3 = taulvec_opt;
output_vec_opt3 = output_vec_opt;
DY3 = DY;

N=length(timevec);

Tmax = 50;
figure(2)
set(gcf,'PaperPosition',[0 0 15 5])
subplot(1,2,1)
h1 = plot(timevec,zeros(1,N),'b--',timevec,taulvec_opt1,'r:',timevec,taulvec_opt2,'k-.',timevec,taulvec_opt3,'g','LineWidth',2);
set(gca,'FontSize',16)
legend(h1,'Equilibrium','Planner, \theta= 0','Planner, \theta= 1/2','Planner, \theta= 1','Location','NorthEast')
xlim([0 Tmax])
title('(a) Credit Subsidy, $\varsigma_k(t)$','interpreter','latex')
xlabel('Years','FontSize',16,'interpreter','latex')
set(findobj('color','g'),'Color',[0 0.5 0]);

subplot(1,2,2)
h1 = plot(timevec,output_vec_lf/output_vec_lf(end),'b--',timevec,output_vec_opt1/output_vec_lf(end),'r:',timevec,output_vec_opt2/output_vec_lf(end),'k-.',timevec,output_vec_opt3/output_vec_lf(end),'g','LineWidth',2);
set(gca,'FontSize',16)
legend(h1,'Equilibrium','Planner, \theta= 0','Planner, \theta= 1/2','Planner, \theta= 1','Location','SouthEast')
xlim([0 Tmax])
title('(b) GDP, $Y(t)$','interpreter','latex')
xlabel('Years','FontSize',16,'interpreter','latex')
set(findobj('color','g'),'Color',[0 0.5 0]);

print -depsc graphs/appendix/fig_numerical_credit.eps